package Crociera.Util;

import java.sql.*;

public class ConnectionManager
{	
	/*	CONNESSIONE NON STATICA
	 *
     *	Per evitare problemi di concorrenza e per facilitare la 
     *	gestione delle transazioni, ogni istanza di ConnectionManager
     *	 proprietaria di una sua connessione (NSConnection).
     */
     
	public Connection NSConnection;		// NS = non statica
    
    //	Costruttore
    public ConnectionManager() throws SQLException {				
		NSConnection = ConnectionManager.createConnection();
    }
    
    /*	Questo metodo restituisce la connessione (non statica) 
     *	per accedere al DataBase.
     */
    
    public Connection getConnection() {
    	return NSConnection;
    }
    
    /*	Questo metodo crea una connessione (Connection) per accedere
     *	al DataBase e la restituisce al costruttore.
     */
    private static Connection createConnection() {
    	Connection connection = null;
    	//String MY_DRIVER = "oracle.lite.poljdbc.POLJDBCDriver";
    	//String MY_URL = "jdbc:polite:Crociera";
    	String MY_DRIVER = "sun.jdbc.odbc.JdbcOdbcDriver";		
		String MY_URL = "jdbc:odbc:Crociera";
		String LOGIN = "system";
        String PASSWD = "manager";

        try {
            Class.forName(MY_DRIVER);
            connection = DriverManager.getConnection(MY_URL, LOGIN, PASSWD);
            connection.setReadOnly(false);
            connection.setAutoCommit(false);
       	} catch (ClassNotFoundException e) { 
       		System.out.println("Driver NON TROVATO");
       	} catch (SQLException e) {
       		e.printStackTrace();
       	}
		return connection;
    }
    
    /*	Questo metodo chiude la connessione non statica
     */
    public void closeConnection() throws SQLException {
     	NSConnection.close();
    }
}