function ControlloreSuddivisioneCabine(campoSingole,campoDoppie,campoQuadruple)
{
	this.campoSingole=campoSingole;
	this.campoDoppie=campoDoppie;
	this.campoQuadruple=campoQuadruple;

	this.viaggiatori=0;
	this.bambini=0;
	this.adulti=0;
	
	this.totaleSingole=0;
	this.totaleDoppie=0;
	this.totaleQuadruple=0;
	this.singole=0;
	this.doppie=0;
	this.quadruple=0;
	this.totalePosti=0;
	
	this.setViaggiatori=setViaggiatoriControlloreSuddivisioneCabine;
	this.setMaxCabine=setMaxCabine;
	this.setCabineSelezionate=setCabineSelezionate;
	
	this.getTotalePosti=getTotalePosti;
	
	this.singoleChanged=singoleChanged;
	this.doppieChanged=doppieChanged;
	this.quadrupleChanged=quadrupleChanged;
	
	this.svuotaCampoSingole=svuotaCampoSingole;
	this.svuotaCampoDoppie=svuotaCampoDoppie;
	this.svuotaCampoQuadruple=svuotaCampoQuadruple;
	
	this.updateSingole=updateSingole;
	this.updateDoppie=updateDoppie;
	this.updateQuadruple=updateQuadruple;
		
	this.campoSingole.options[0]=new Option('--',0);
	this.campoQuadruple.options[0]=new Option('--',0);
	this.campoDoppie.options[0]=new Option('--',0);

	this.setMaxCabine(null,null,null);
	this.campoSingole.disabled=true;
	this.campoQuadruple.disabled=true;
	this.campoDoppie.disabled=true;

}

function setMaxCabine(maxSingole,maxDoppie,maxQuadruple){
	this.maxSingole=maxSingole;
	this.maxDoppie=maxDoppie;
	this.maxQuadruple=maxQuadruple;
}

function setCabineSelezionate(singole,doppie,quadruple){
	if(this.totaleSingole>=singole) {
		this.singole=singole;
		this.campoSingole.options[singole].selected=true;
	}
	if(this.totaleDoppie>=doppie) {
		this.doppie=doppie;
		this.campoDoppie.options[doppie].selected=true;
	}
	if(this.totaleQuadruple>=quadruple) {
		this.quadruple=quadruple;
		this.campoQuadruple.options[quadruple].selected=true;
	}
}

function singoleChanged()
{
	this.singole=Number(this.campoSingole.options[this.campoSingole.selectedIndex].value);
	if(this.getTotalePosti() > this.viaggiatori) {
		this.doppie=0;
		this.campoDoppie.options[0].selected=true;
		this.quadruple=0;
		this.campoQuadruple.options[0].selected=true;
	}
}
function doppieChanged()
{
	this.doppie=Number(this.campoDoppie.options[this.campoDoppie.selectedIndex].value);
	if(this.getTotalePosti() > this.viaggiatori) {
		this.singole=0;
		this.campoSingole.options[0].selected=true;
		this.quadruple=0;
		this.campoQuadruple.options[0].selected=true;
	}
}
function quadrupleChanged()
{
	this.quadruple=Number(this.campoQuadruple.options[this.campoQuadruple.selectedIndex].value);
	if(this.getTotalePosti() > this.viaggiatori) {
		this.singole=0;
		this.campoSingole.options[0].selected=true;
		this.doppie=0;
		this.campoDoppie.options[0].selected=true;
	}
}

function setViaggiatoriControlloreSuddivisioneCabine(viaggiatori,bambini)
{
	if(viaggiatori!=null)
		this.viaggiatori=viaggiatori;
	if(bambini!=null)
		this.bambini=bambini;
	this.adulti=this.viaggiatori-this.bambini;
	this.updateSingole();
	this.updateDoppie();
	this.updateQuadruple();
}

function svuotaCampoSingole()
{
	while(true)
		if(this.campoSingole.options[1]!=null)
			this.campoSingole.options[1]=null;
		else break;
}
function svuotaCampoDoppie()
{
	while(true)
		if(this.campoDoppie.options[1]!=null)
			this.campoDoppie.options[1]=null;
		else break;
}
function svuotaCampoQuadruple()
{
	while(true)
		if(this.campoQuadruple.options[1]!=null)
			this.campoQuadruple.options[1]=null;
		else break;
}

function updateSingole()
{
	//var totaleSingole=this.viaggiatori;
	var totaleSingole=this.adulti-Math.floor(this.bambini/3);
	if(totaleSingole>0) {
		this.campoSingole.disabled=false;
		if(this.maxSingole!=null && this.maxSingole<totaleSingole)
			totaleSingole=this.maxSingole;
		if(totaleSingole>this.totaleSingole) {
			for(var i=this.totaleSingole+1;i<=totaleSingole;i++)
				this.campoSingole.options[i]=new Option(i,i);
		}
		else if(totaleSingole<this.totaleSingole)
			for(var i=this.totaleSingole;i>totaleSingole;i--)
				this.campoSingole.options[i]=null;
		this.totaleSingole=Number(totaleSingole);
	} else {
		this.svuotaCampoSingole();
		this.campoSingole.options[0].selected=true;
		this.campoSingole.disabled=true;
		this.totaleSingole=0;
		this.singole=0;
	}
}

function updateDoppie()
{
	var totaleDoppie=Math.floor(this.viaggiatori/2);
	if(totaleDoppie>this.adulti)
		totaleDoppie=this.adulti;
	
	if(totaleDoppie>0) {
		this.campoDoppie.disabled=false;
		if(this.maxDoppie!=null && this.maxDoppie<totaleDoppie)
			totaleDoppie=this.maxDoppie;
		if(totaleDoppie>this.totaleDoppie) {
			for(var i=this.totaleDoppie+1;i<=totaleDoppie;i++)
				this.campoDoppie.options[i]=new Option(i,i);
		}
		else if(totaleDoppie<this.totaleDoppie)
			for(var i=this.totaleDoppie;i>totaleDoppie;i--)
				this.campoDoppie.options[i]=null;
		this.totaleDoppie=Number(totaleDoppie);
	} else {
		this.svuotaCampoDoppie();
		this.campoDoppie.options[0].selected=true;
		this.campoDoppie.disabled=true;
		this.totaleDoppie=0;
		this.doppie=0;
	}
}
function updateQuadruple()
{
	var totaleQuadruple=Math.floor(this.viaggiatori/3);
	if(totaleQuadruple>this.adulti)
		totaleQuadruple=this.adulti;
	
	if(totaleQuadruple>0) {
		this.campoQuadruple.disabled=false;
		if(this.maxQuadruple!=null && this.maxQuadruple<totaleQuadruple)
			totaleQuadruple=this.maxQuadruple;
		if(totaleQuadruple>this.totaleQuadruple) {
			for(var i=this.totaleQuadruple+1;i<=totaleQuadruple;i++)
				this.campoQuadruple.options[i]=new Option(i,i);
		}
		else if(totaleQuadruple<this.totaleQuadruple)
			for(var i=this.totaleQuadruple;i>totaleQuadruple;i--)
				this.campoQuadruple.options[i]=null;
		this.totaleQuadruple=Number(totaleQuadruple);
	} else {
		this.svuotaCampoQuadruple();
		this.campoQuadruple.options[0].selected=true;
		this.campoQuadruple.disabled=true;
		this.totaleQuadruple=0;
		this.quadruple=0;
	}
}
function getTotalePosti()
{
	//nelle singole deve stare una persone, nelle doppie 2, nelle quadruple almeno 3
	return this.singole+this.doppie*2+this.quadruple*3;
}

function ControlloreCampoBambini(campoBambini, viaggiatori, bambini)
{
	this.campoBambini=campoBambini;
	this.viaggiatori=0;
	this.bambini=0;
	this.maxBambini=0;

	this.setViaggiatori=setViaggiatoriControlloreCampoBambini;
	this.svuotaListaBambini=svuotaListaBambini;
	
	this.campoBambini.options[0]=new Option('--','0');
	var maxBambini;
	var adulti=viaggiatori-bambini;
	if(viaggiatori!=null && bambini!=null && adulti>0) {
		maxBambini=adulti*3;
		for(var i=1;i<=maxBambini;i++)
			this.campoBambini.options[i]=new Option(String(i),String(i));
		if(bambini<=maxBambini) {
			this.campoBambini.options[Number(bambini)].selected=true;
			this.bambini=bambini;
		} else {
			this.bambini=0;
			this.campoBambini.options[0].selected=true;
		}
		this.maxBambini=maxBambini;
		this.viaggiatori=viaggiatori;
		this.adulti=adulti;
	}
	else {
		this.campoBambini.options[0].selected=true;
		this.campoBambini.disabled=true;
	}
}

function setViaggiatoriControlloreCampoBambini(viaggiatori)
{
	this.viaggiatori=viaggiatori;
	var minAdulti=Math.ceil(viaggiatori/3);
	var maxBambiniNew=viaggiatori-minAdulti;
	if(maxBambiniNew > 0){
		if(maxBambiniNew > this.maxBambini) {
			for(var i=this.maxBambini+1;i<=maxBambiniNew;i++)
				this.campoBambini.options[i]=new Option(String(i),String(i));
		} else if(maxBambiniNew < this.maxBambini) {
			for(var i=this.maxBambini;i>maxBambiniNew;i--)
				this.campoBambini.options[i]=null;
		}
		this.maxBambini=maxBambiniNew;
		this.campoBambini.disabled=false;
	} else {
		this.svuotaListaBambini();
		this.maxBambini=0;
		this.campoBambini.options[0].selected=true;
		this.campoBambini.disabled=true;
	}
}

function svuotaListaBambini(){
	while(true) {
		if(this.campoBambini.options[1]!=null)
			this.campoBambini.options[1]=null;
		else break;
	}
}

	